#include <Pilot.h>


#define LISTING_START_Y 38

#define VERSION "0.6.2.1"

/*
 * convert.c
 */

/* Allocate and initialize disassembler internal structures */
int
initialize_disassembler(void);

/* Destroy and free all disassemble internal structures and whatnot. */
void
terminate_disassembler(void);


/* Decode input data at address <addr> into a single instruction. No more. No
 * less.  Returns the address of the next instruction, or NULL on failure.
 */
void *
disassemble_single_line(void *addr);

/* Set the line-counter of the output function. */
void
disassemble_set_line(int line);

/* Set whether to output hex opcodes or not (i.e. only memnonics). */
void
disassemble_set_detail(int full);

/* Set the output format. */
void
disassemble_set_displaystate(int newstate);

/* Set whether to output absolute or relative branch addresses */
void
disassemble_set_branchtype(int branchtype);

/* Set whether to show system calls by their name or number. */
void
disassemble_set_syscall(int state);

enum displaystate { DISP_DISASM, DISP_HEX };		/* output formats */
enum branchstate { BRANCH_FULL, BRANCH_RELATIVE };	/* branch types */

/* Attempt to read 8 bits from address <from>. Returns the byte read, or 0x0100
 * on failure. */
unsigned int Read_Byte(void *from);

/* update codes for mainform. */
#define UPDATE_LISTING	0xc001
#define REFRESH_LISTING	0xc002
#define SHOW_DB_LIST	0xd001
#define SHOW_REC_LIST	0xd002

/*
 * pilot-trap.c
 */


/* Returns the name of systrap given the following 16 bits after a TRAP #15;
 * <trap>. If an unknow systrap, return a string containing the hex value of
 * the systrap. */
const char *
pilot_trap_name(unsigned long trap, int namestate);

const char *
make_trap_name(unsigned long trap, unsigned long base, int rID);
